%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                      Class
%pmatrix_obj_data            data        pmatrix_obj            avg_g(pmatrix_obj)                                 double
%                                                               cvar_risk(parameter_alpha,pmatrix_obj)
%pmatrix_obj_vars            vars        pmatrix_obj            avg_g(pmatrix_obj)                                 cell
%                                                               cvar_risk(parameter_alpha,pmatrix_obj)
%pmatrix_constraint1_data    data        pmatrix_constraint1    max_risk(pmatrix_constraint1)                      double
%pmatrix_constraint1_vars    vars        pmatrix_constraint1    max_risk(pmatrix_constraint1)                      cell
%pmatrix_constraint2_data    data        pmatrix_constraint2    max_risk(pmatrix_constraint2)                      double
%pmatrix_constraint2_vars    vars        pmatrix_constraint2    max_risk(pmatrix_constraint2)                      cell
%parameter_bound_data        data        parameter_bound        Constraint: <= parameter_bound, linearize = 1      double
%parameter_alpha_data        data        parameter_alpha        cvar_risk(parameter_alpha,pmatrix_obj)             double
%parameter_bound_1_data      data        parameter_bound_1      Constraint: <= parameter_bound_1, linearize = 1    double
%parameter_bound_2_data      data        parameter_bound_2      Constraint: <= parameter_bound_2, linearize = 1    double
%parameter_bound_3_data      data        parameter_bound_3      Box: >= parameter_bound_3, <= parameter_bound_4    double
%parameter_bound_4_data      data        parameter_bound_4      Box: >= parameter_bound_3, <= parameter_bound_4    double
%parameter_solver_data       data        parameter_solver       Solver: parameter_solver                           char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(pmatrix_obj_data,pmatrix_obj_vars,pmatrix_constraint1_data,pmatrix_constraint1_vars,pmatrix_constraint2_data,pmatrix_constraint2_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data,parameter_bound_3_data,parameter_bound_4_data,parameter_solver_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_obj',pmatrix_obj_vars,pmatrix_obj_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_constraint1',pmatrix_constraint1_vars,pmatrix_constraint1_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_constraint2',pmatrix_constraint2_vars,pmatrix_constraint2_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  avg_g(pmatrix_obj)',...
'Constraint: <= parameter_bound, linearize = 1',...
'  cvar_risk(parameter_alpha,pmatrix_obj)',...
'Constraint: <= parameter_bound_1, linearize = 1',...
'  max_risk(pmatrix_constraint1)',...
'Constraint: <= parameter_bound_2, linearize = 1',...
'  max_risk(pmatrix_constraint2)',...
'Box: >= parameter_bound_3, <= parameter_bound_4',...
'Solver: parameter_solver',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound_3',num2str(parameter_bound_3_data));
problem_statement = strrep(problem_statement,'parameter_bound_4',num2str(parameter_bound_4_data));
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

