%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%maximize
%avg_g(pmatrix_obj)
%Constraint: <= parameter_bound, linearize = 1
%cvar_risk(parameter_alpha,pmatrix_obj)
%Constraint: <= parameter_bound_1, linearize = 1
%max_risk(pmatrix_constraint1)
%Constraint: <= parameter_bound_2, linearize = 1
%max_risk(pmatrix_constraint2)
%Box: >= parameter_bound_3, <= parameter_bound_4
%Solver: parameter_solver
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                      Class
%pmatrix_obj_data            data        pmatrix_obj            avg_g(pmatrix_obj)                                 double
%                                                               cvar_risk(parameter_alpha,pmatrix_obj)
%pmatrix_obj_vars            vars        pmatrix_obj            avg_g(pmatrix_obj)                                 cell
%                                                               cvar_risk(parameter_alpha,pmatrix_obj)
%pmatrix_constraint1_data    data        pmatrix_constraint1    max_risk(pmatrix_constraint1)                      double
%pmatrix_constraint1_vars    vars        pmatrix_constraint1    max_risk(pmatrix_constraint1)                      cell
%pmatrix_constraint2_data    data        pmatrix_constraint2    max_risk(pmatrix_constraint2)                      double
%pmatrix_constraint2_vars    vars        pmatrix_constraint2    max_risk(pmatrix_constraint2)                      cell
%parameter_bound_data        data        parameter_bound        Constraint: <= parameter_bound, linearize = 1      double
%parameter_alpha_data        data        parameter_alpha        cvar_risk(parameter_alpha,pmatrix_obj)             double
%parameter_bound_1_data      data        parameter_bound_1      Constraint: <= parameter_bound_1, linearize = 1    double
%parameter_bound_2_data      data        parameter_bound_2      Constraint: <= parameter_bound_2, linearize = 1    double
%parameter_bound_3_data      data        parameter_bound_3      Box: >= parameter_bound_3, <= parameter_bound_4    double
%parameter_bound_4_data      data        parameter_bound_4      Box: >= parameter_bound_3, <= parameter_bound_4    double
%parameter_solver_data       data        parameter_solver       Solver: parameter_solver                           char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Optimal Position Liquidation with CVaR Constraints\data_problem_optimalexe_cvar_risk_10_short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(pmatrix_obj_data,pmatrix_obj_vars,pmatrix_constraint1_data,pmatrix_constraint1_vars,pmatrix_constraint2_data,pmatrix_constraint2_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data,parameter_bound_3_data,parameter_bound_4_data,parameter_solver_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
